
/* Controller.h - written by Robert Vasvari 6/94 */
#import <appkit/appkit.h>

@interface Controller:Object
{
	id docList;
	id currentDoc;	 //document that has the key window
	id newDoc;       //used for new documents
	const char *fileName;
	id prefManager;
	id inspectorManager;
	id infoPanel;
	NXZone *controllerZone;
	id accessoryView;
}

/* ==== init section ==== */
+ initialize;
- init;
- appDidInit:sender;

/* ==== document management section ==== */
- openFile:sender;
- createDocumentObject:sender;
- openDocument:(const char *)aPath;
- newDocument:sender;
- save:sender;
- saveAs:sender;
- saveTo:sender;
- saveAll:sender;
- revert:sender;
- close:sender;
- freeDoc:aDoc;
- findDocWithPath:(const char *)aPath;
- findDocWithTag:(int)aTag;

/* ==== panels ==== */
- getPrefsPanel:sender;
- getInspectorPanel:sender;
- (BOOL)getInspectorPanelWithScreen:(int)aScreen;
- getInfoPanel:sender;

/* ==== access to instance variables ==== */
- setCurrentDoc:aDoc;
- currentDoc;

/* ==== application delegate methods ==== */
- (BOOL)appAcceptsAnotherFile:sender;
- (int)appOpenFile:(const char *)path type:(const char *)type;
- appWillTerminate:sender;


@end
